 //////////////////////////////////////////////////////////////////////
//  vWFNg  :  MAC2IP
//
//  t@C  :  Gg[C
//
//  J      :  Visual Studio 2019
//
//  @@    :  2020/ 2/13
//
//  @@    :  ElementTech  Hidetoshi Matsui
//////////////////////////////////////////////////////////////////////
#include  "MAC2IP.h"
#include  "MAC2IPClass.h"

//////////////////////////////////////////////////////////////////////
//        R[obN֐`
//////////////////////////////////////////////////////////////////////
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);

//////////////////////////////////////////////////////////////////////
//        vCx[g vg^Cv錾
//////////////////////////////////////////////////////////////////////
ATOM		WinRegisterClass(HINSTANCE p_hInstance, LPCTSTR p_pctszClass);
HWND		InitInstance(HINSTANCE p_hInstance, LPCTSTR p_pctszClass, LPCTSTR p_pctszTitle, int p_nCmdShow, MACIPClass* p_pClass);

//////////////////////////////////////////////////////////////////////
//        C Gg[
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//  ց@@   :  _tWinMain
//
//  @@@@\   :  EBhE C Gg[
//
//  p[^   :  HINSTANCE  p_hInstance      <- vOCX^X
//                  HINSTANCE  p_hPrevInstance  <- 1ÕCX^X
//                  LPTSTR     p_ptszCmdLine    <- R}hC̕
//                  int        p_nCmdShow       <- \R}h
//
//  ߁@@l   :  IR[h
//
//  @@   :  2020/ 3/13   by H.m
//////////////////////////////////////////////////////////////////////
int		APIENTRY _tWinMain(HINSTANCE p_hInstance, HINSTANCE p_hPrevInstance, LPTSTR p_ptszCmdLine, int p_nCmdShow)
{
	// gpp[^̑Ή
	UNREFERENCED_PARAMETER(p_hPrevInstance);
	UNREFERENCED_PARAMETER(p_ptszCmdLine);

	// gpϐ
	MSG		msg;
	ZeroMemory(&msg, sizeof(msg));

	// C NX쐬
	MACIPClass* pMACIPClass = new MACIPClass(p_hInstance);

	// O[o
	TCHAR	tszTitle[MAX_LOADSTRING];
	TCHAR	tszWindowClass[MAX_LOADSTRING];
	LoadString(p_hInstance, IDS_APP_TITLE, tszTitle, MAX_LOADSTRING);
	LoadString(p_hInstance, IDS_APP_CLASS, tszWindowClass, MAX_LOADSTRING);
	WinRegisterClass(p_hInstance, tszWindowClass);

	// AvP[V̏
	HWND hWnd = InitInstance(p_hInstance, tszWindowClass, tszTitle, p_nCmdShow, pMACIPClass);
	if (hWnd != NULL)	{
		// L[ANZ[^[ݒ
		HACCEL hAccelTable = LoadAccelerators(p_hInstance, MAKEINTRESOURCE(IDS_ACCELE));

		// bZ[W [v:
		while (GetMessage(&msg, NULL, 0, 0))	{
			if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg))	{
				if (!IsDialogMessage(msg.hwnd, &msg)) {
					TranslateMessage(&msg);
					DispatchMessage(&msg);
				}
			}
		}

		// C NX폜
		delete pMACIPClass;
	}
	return (int)msg.wParam;
}

//////////////////////////////////////////////////////////////////////
//        vCx[g֐
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//  ց@@   :  WinRegisterClass
//
//  @@@@\   :  EBhENXo^܂B
//
//  p[^   :  HINSTANCE  p_hInstance   <- vOCX^X
//                  LPCTSTR    p_pctszClass  <- NX
//
//  ߁@@l   :  ATOM
//
//  @@   :  2020/ 3/13   by H.m
//////////////////////////////////////////////////////////////////////
ATOM	WinRegisterClass(HINSTANCE p_hInstance, LPCTSTR p_pctszClass)
{
	// EBhENXo^
	WNDCLASSEX wcex;
	wcex.cbSize			= sizeof(WNDCLASSEX);
	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra	= sizeof(MACIPClass*);
	wcex.hInstance		= p_hInstance;
	wcex.hIcon			= LoadIcon(p_hInstance, MAKEINTRESOURCE(IDI_MACIP));
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= MAKEINTRESOURCE(IDS_ACCELE);
	wcex.lpszClassName	= p_pctszClass;
	wcex.hIconSm		= LoadIcon(p_hInstance, MAKEINTRESOURCE(IDI_MACIP));

	return RegisterClassEx(&wcex);
}

//////////////////////////////////////////////////////////////////////
//  ց@@   :  InitInstance
//
//  @@@@\   :  CX^X܂B
//
//  p[^   :  HINSTANCE  p_hInstance     <- vOCX^X
//                  LPCTSTR    p_pctszClass    <- NX
//                  LPCTSTR    p_pctszTitle    <- EChE^Cg
//                  int        p_nCmdShow      <- \R}h
//                  MACIPClass*	p_pMACIPClass  <- NXCX^X
//
//  ߁@@l   :  HWND  EChEnh
//
//  @@   :  2020/ 3/13   by H.m
//////////////////////////////////////////////////////////////////////
HWND		InitInstance(HINSTANCE p_hInstance, LPCTSTR p_pctszClass, LPCTSTR p_pctszTitle, int p_nCmdShow, MACIPClass* p_pMACIPClass)
{
	// EBhE쐬
	DWORD dwStyle = WS_POPUPWINDOW;
	DWORD dwExStyle = WS_EX_ACCEPTFILES;
	HWND hWnd = CreateWindowEx(dwExStyle, p_pctszClass, p_pctszTitle, dwStyle, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, NULL, NULL, p_hInstance, p_pMACIPClass);
	if (hWnd != NULL)	{
		// EBhEXV
		ShowWindow(hWnd, p_nCmdShow);
		UpdateWindow(hWnd);
	}
	return hWnd;
}

//////////////////////////////////////////////////////////////////////
//        EBhE vV[W[
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//  ց@@   :  WndProc
//
//  @@@@\   :  EChEbZ[WGg[
//
//  p[^   :  HWND    p_hWnd      <- EChEnh
//                  UINT    p_uMessage  <- bZ[W
//                  WPARAM  p_wParam    <- p[^
//                  LPARAM  p_lParam    <- gp[^
//
//  ߁@@l   :  LRESULT
//
//  @@   :  2020/ 3/13   by H.m
//////////////////////////////////////////////////////////////////////
LRESULT CALLBACK WndProc(HWND p_hWnd, UINT p_uMessage, WPARAM p_wParam, LPARAM p_lParam)
{
	LRESULT		lResult;

	// NXCX^X擾
	MACIPClass* pMACIP = (MACIPClass*)GetWindowLongPtr(p_hWnd, GWLP_USERDATA);
	if (pMACIP == NULL)	{
		// WM_CREATEŏ
		if (p_uMessage == WM_CREATE)	{
			// NXCX^Xݒ
			LPCREATESTRUCT	lpcs;
			lpcs = (LPCREATESTRUCT)p_lParam;
			pMACIP = (MACIPClass*)lpcs->lpCreateParams;
			SetWindowLongPtr(p_hWnd, GWLP_USERDATA, (LONG_PTR)pMACIP);
			lResult = pMACIP->wndProc(p_hWnd, p_uMessage, p_wParam, p_lParam);
		}
		else	{
			lResult = DefWindowProc(p_hWnd, p_uMessage, p_wParam, p_lParam);
		}
	}
	else	{
		lResult = pMACIP->wndProc(p_hWnd, p_uMessage, p_wParam, p_lParam);
	}
	return lResult;
}

